#include "listType.bi"

type listValue
    nextL as listValue ptr 
    prevL as listValue ptr 
    value as listType
end type



type list
    f as listValue ptr
    c as integer

    declare constructor ()
    
    declare sub add(byval t as listType)
    declare sub append (byval t as listType)
    declare sub prepend (byval t as listType)
    declare sub remove(byval i as integer)
    declare sub removeOne(byval t as listType)
    declare sub removeAll(byval t as listType)
    declare sub erase(byval s as integer, byval e as integer)
    declare sub insert(byval index as integer, byval t as listType)
    declare sub move(byval from as integer, byval t as integer)
    
    declare function get(byval i as integer) as listType
    declare function value(byval i as integer) as listType
    declare function value(byval i as integer, byval default as listType) as listType
    
    declare function first() as listType
    declare function last() as listType
    declare sub removeFirst()
    declare sub removeLast()
    
    declare function count overload () as integer
    declare function count(byval t as listType) as integer
    declare sub clear()
    
    declare function take (byval i as integer) as listType
    declare function takeFirst () as listType
    declare function takeLast () as listType
    
    declare function isEmpty() as integer
    
    declare sub replace (byval i as integer, byval t as listType)
    declare sub swapItems (byval i as integer, byval j as integer)
    
    declare function indexOf(byval t as listType) as integer
    declare function lastIndexOf(byval t as listType) as integer
    declare function contains(byval t as listType) as integer
    
    declare function startsWith(byval t as listType) as integer
    declare function endsWith(byval t as listType) as integer
    
    declare function mid (byval p as integer, byval l as integer) as list
    
    declare operator += (byval t as listType)
end type


constructor list
    f = 0
    c = 0
end constructor


sub list.add(byval t as listType)
    dim as listValue ptr v
    v = f
    if v = 0 then
        f = new listValue
        f->nextL = 0
        f->prevL = 0
        f->value = t
        c = c + 1
        exit sub
    end if
    
    do
        if v->nextL = 0 then
            exit do
        end if
        v = v->nextL
    loop
    v->nextL = new listValue
    v->nextL->nextL = 0
    v->nextL->prevL = v
    v->nextL->value = t
    c = c + 1
end sub


sub list.remove(byval i2 as integer)
    dim as listValue ptr v
    dim as integer i = 0
    v = f
    if i2 < 1 or i2 > c then
        exit sub
    end if
    
    do
        i = i + 1
        if i = i2 then exit do
        v = v->nextL
    loop
    if v->nextL <> 0 and v->prevL <> 0 then
        v->nextL->prevL = v->prevL
        v->prevL->nextL = v->nextL
        delete v
        c = c - 1
    elseif v->prevL = 0 and v->nextL <> 0 then
        f = v->nextL
        f->prevL = 0
        delete v
        c = c - 1
    elseif v->nextL = 0 and v->prevL <> 0 then
        v->prevL->nextL = 0
        delete v
        c = c - 1
    else
        f = 0
        delete v
        c = 0
    end if
end sub


sub list.erase(byval s as integer, byval e as integer)
    if s < 1 or s > c or e < 1 or e > c then exit sub
    dim temp as integer
    if s > e then
        temp = s
        s = e
        e = temp
    end if
    if s = e then exit sub
    dim i as integer = e - s
    dim as integer i2 = 0
    do
        remove(s)
        i2 = i2 + 1
        if i2 = i then exit sub
    loop
end sub


function list.get(byval i2 as integer) as listType
    dim as listValue ptr v
    dim as integer i = 0
    v = f
    if i2 < 1 or i2 > c then
        return listType
    end if
    
    do
        i = i + 1
        if i = i2 then exit do
        v = v->nextL
    loop
    return v->value
end function


function list.value(byval i2 as integer) as listType
    return get(i2)
end function


function list.value(byval i2 as integer, byval default as listType) as listType
    if i2 < 1 or i2 > c then return default
    return get(i2)
end function


function list.first() as listType
    if c > 0 then 
        return f->value
    else
        return listType
    end if
end function


function list.last() as listType
    if c > 0 then 
        return get(c)
    else
        return listType
    end if
end function


function list.count() as integer
    return c
end function


function list.count(byval t as listType) as integer
    dim as listValue ptr v
    dim c2 as integer = 0
    dim as integer i = 0
    v = f
    if c = 0 then
        return 0
    end if
    
    do
        i = i + 1
        if get(i) = t then c2 = c2 + 1
        if i = c then exit do
    loop
    return c2
end function


sub list.clear()
    do
        remove(1)
    loop until c = 0
end sub


function list.isEmpty() as integer
    if c = 0 then return -1
    return 0
end function


sub list.replace(byval i2 as integer, byval t as listType)
    dim as listValue ptr v
    dim as integer i = 0
    v = f
    if i2 < 1 or i2 > c then
        exit sub
    end if
    
    do
        i = i + 1
        if i = i2 then exit do
        v = v->nextL
    loop
    v->value = t
end sub


sub list.swapItems(byval i2 as integer, byval j as integer)
    dim as listType t1, t2
    
    dim as listValue ptr v
    dim as integer i = 0
    v = f
    if i2 < 1 or i2 > c then
        exit sub
    end if
    
    do
        i = i + 1
        if i = i2 then exit do
        v = v->nextL
    loop
    
    dim as listValue ptr v2
    i = 0
    v2 = f
    if j < 1 or j > c then
        exit sub
    end if
    
    do
        i = i + 1
        if i = j then exit do
        v2 = v2->nextL
    loop
    
    t1 = v->value
    t2 = v2->value
    v->value = t2
    v2->value = t1
end sub


function list.indexOf(byval t as listType) as integer
    dim as listValue ptr v
    dim as integer i = 0
    v = f
    if c = 0 then
        return -1
    end if
    
    do
        i = i + 1
        if get(i) = t then return i
        if i = c then exit do
    loop
    return -1
end function


function list.lastIndexOf(byval t as listType) as integer
    dim as listValue ptr v
    dim as integer i = c+1
    v = f
    if c = 0 then
        return -1
    end if
    
    do
        i = i - 1
        if get(i) = t then return i
        if i = 0 then exit do
    loop
    return -1
end function


function list.contains(byval t as listType) as integer
    dim as integer i = indexOf(t)
    if i = -1 then return 0
    return -1
end function


sub list.removeFirst()
    remove(1)
end sub


sub list.removeLast()
    remove(c)
end sub


sub list.removeAll(byval t as listType)
    dim i as integer = 0
    if c < 1 then exit sub
    do
        i = i + 1
        if get(i) = t then remove(i)
    loop until i >= c
end sub


sub list.removeOne(byval t as listType)
    dim i as integer = 0
    if c < 1 then exit sub
    do
        i = i + 1
        if get(i) = t then 
            remove(i)
            exit sub
        end if
    loop until i >= c
end sub


sub list.append(byval t as listType)
    add(t)
end sub


sub list.prepend(byval t as listType)
    if c = 0 then 
        add(t)
        exit sub
    end if
    dim as listValue ptr v = new listValue
    dim as listValue ptr v2 = f
    f = new listValue
    f->nextL = v2
    f->prevL = 0
    f->value = t
    v2->prevL = f
    c = c + 1
end sub


sub list.insert(byval i2 as integer, byval t as listType)
    dim as listValue ptr v
    dim as integer i = 0
    v = f
    if i2 < 1 or i2 > c then
        exit sub
    end if
    
    do
        i = i + 1
        if i = i2 then exit do
        v = v->nextL
    loop
    dim as listValue ptr v2 = new listValue
    if v->nextL <> 0 and v->prevL <> 0 then
        v2->nextL = v
        v2->prevL = v->prevL
        
        v->prevL->nextL = v2
        v->prevL = v2
        
        
        v2->value = t
        c = c + 1
    elseif v->prevL = 0 and v->nextL <> 0 then
        prepend(t)
        delete v2
    elseif v->prevL <> 0 and v->nextL = 0 then
        add(t)
        delete v2
    end if
    
end sub


sub list.move(byval from as integer, byval t as integer)
    if from < 1 or from > c or t < 1 or t > c then
        exit sub
    end if
    insert(t+1,get(from))
    remove(from)
end sub


function list.startsWith(byval t as listType) as integer
    if c > 0 and first() = t then return -1
    return 0
end function


function list.endsWith(byval t as listType) as integer
    if c > 0 and last() = t then return -1
    return 0
end function


function list.take (byval i as integer) as listType
    dim as listType v = get(i)
    remove(i)
    return v
end function


function list.takeFirst () as listType
    dim as listType v = first()
    removeFirst()
    return v
end function


function list.takeLast () as listType
    dim as listType v = last()
    removeLast()
    return v
end function


function list.mid(byval i2 as integer,byval l as integer) as list
    dim as listValue ptr v
    dim as integer i = 0
    v = f
    if i2 < 1 or i2 > c then
        return list
    end if
    
    if l = -1 then l = c - i2 + 1
    do
        i = i + 1
        if i = i2 then exit do
        v = v->nextL
    loop
    
    dim as list l3
    i = 0
    do
        l3.append(v->value)
        i = i + 1
        v = v->nextL
        if i = l then return l3
    loop
    return l3
end function


operator list.+= (byval t as listType)
    append(t)
end operator


operator = (byval l1 as list, byval l2 as list) as byte
    if l1.c = l2.c then
        if l1.c = 0 then
            return -1
        end if
        
        dim as listValue ptr v
        dim as integer i = 0
        v = l1.f
    
        dim as listValue ptr v2
        v2 = l2.f
        do
            i = i + 1
            if v->value = v2->value then return 0
            if i = l1.c or i = l2.c then exit do
            v = v->nextL
            v2 = v2->nextL
        loop
        return -1
    end if
    return 0
end operator


operator <> (byval l1 as list, byval l2 as list) as byte
    if l1.c = l2.c then
        if l1.c = 0 then
            return 0
        end if
        
        dim as listValue ptr v
        dim as integer i = 0
        v = l1.f
    
        dim as listValue ptr v2
        v2 = l2.f
        do
            i = i + 1
            if v->value = v2->value then return -1
            if i = l1.c or i = l2.c then exit do
            v = v->nextL
            v2 = v2->nextL
        loop
        return 0
    end if
    return -1
end operator


operator + (byval l1 as list, byval t as listType) as list
    l1.add(t)
    return l1
end operator


operator + (byval t as listType, byval l1 as list) as list
    l1.prepend(t)
    return l1
end operator


operator - (byval l1 as list, byval t as listType) as list
    l1.removeAll(t)
    return l1
end operator


operator / (byval l1 as list, byval t as listType) as integer
    return l1.count(t)
end operator